#include "UtilTimedImageData.h"

void IplImage2TimedImage(TUT::TimedImageData *data, IplImage *img){

	data->data.depth=img->depth;
	data->data.height=img->height;
	data->data.nChannels=img->nChannels;
	data->data.imageSize=img->imageSize;
	data->data.origin=img->origin;
	data->data.width=img->width;
	int n=(int)img->imageSize;
	data->data.imgData.length(0);
	data->data.imgData.length(n);
	for(int i=0;i<n;i++){
		data->data.imgData[i]=img->imageData[i];
	}
}


IplImage* TimedImageData2IplImage(TUT::TimedImageData *data){
	IplImage *img=cvCreateImage(cvSize(data->data.width,data->data.height),data->data.depth,data->data.nChannels);
	int n=(int)data->data.imageSize;
	for(int i=0;i<n;i++){
		img->imageData[i]=data->data.imgData[i];
	}
	return img;
}
