// ================================================================================== //
// Name of File				: level_set_method.h
// Vendor					: AISL-TUT
// Version					: 2.0.3
// ================================================================================== //

#ifndef __LEVEL_SET__
#define __LEVEL_SET__

/* Function prototypes */
void standardization_func_float(float **in_data, float** out_data);//Normalization of two-dimensional data
float calculate_HJ(CvPoint point,float **timeFunc, float **speedFunc);
void calculate_FIM(unsigned char **LocalMap2, float **speedFunc, float **timeFunc, CvPoint local_subgoal);
unsigned char target_root(unsigned char **LocalMap, IplImage *Gauss_f32, CvPoint local_subgoal);
void calc_dt(unsigned char **LocalMap, IplImage *func_32);

#endif