// ================================================================================== //
// Name of File				: obst_info.cpp
// Vendor					: AISL-TUT
// Version					: 2.0.3
// ================================================================================== //

#include "obst_info.h"
#include <math.h>
const float pi = (float)PI;

#define SIMU_REVERSE_COUNT (54)

short GetMobjeNum_pre;

void MobjeBuilder(M_OBJE **move_obje , M_OBJE *array_Mobje[OBJECT_MAX_NUM] , short *NumOfMobje , RECEIVE_OBST_DATA *data_people , unsigned char **LocalMap , DATA_LOGGER robot_data , short m_counter)
{
	static short GetMobjeNum_now;
	static short ChangeNum;
	static short i;
	static CvPoint local;
	static int step = 0;


	static RECEIVE_OBST_DATA data_pre[OBJECT_MAX_NUM];
	static RECEIVE_OBST_DATA data_pre_tmp[OBJECT_MAX_NUM];

	/** Creating the first moving object **/
	if(*move_obje == NULL){
		*move_obje = new M_OBJE(MobjeR*2/GRID_SIZE,MobjeR*2/GRID_SIZE);
		(*move_obje)->SetCircle(MobjeR/GRID_SIZE);
		(*move_obje)->SetOptionalPolygon(1);
		array_Mobje[0] = *move_obje;
		array_Mobje[0]->SetPosition(3000,-3000);
		GetMobjeNum_pre = 0;
		step = 0;
	}


	GetMobjeNum_now = m_counter;
	*NumOfMobje = GetMobjeNum_now;

	
	if(GetMobjeNum_now < GetMobjeNum_pre){//Delete
		//But do not actually deleted. May not be removed from the array.
	}
	else if(GetMobjeNum_now > GetMobjeNum_pre){//Create
		ChangeNum = GetMobjeNum_now - GetMobjeNum_pre;
		for(i=0;i<ChangeNum;i++){//Bun create as few changes
			if(array_Mobje[i+GetMobjeNum_pre] == NULL){//NULL only when it was made.
				array_Mobje[i+GetMobjeNum_pre-1]->MakeMObje(MobjeR*2/GRID_SIZE,MobjeR*2/GRID_SIZE);
				array_Mobje[i+GetMobjeNum_pre] = (M_OBJE *)array_Mobje[i+GetMobjeNum_pre-1]->next;//Array
				array_Mobje[i+GetMobjeNum_pre]->SetCircle(MobjeR/GRID_SIZE);
				array_Mobje[i+GetMobjeNum_pre]->SetPosition(3000,-3000);
			}
		}
	}

	//Been improved position update rate
	static float velo , dir;
	static int pre=3000;
	if(step%SIMU_REVERSE_COUNT > SIMU_REVERSE_COUNT/2){
		pre += 100;
	}else{
		pre -= 100;
	}

	for(i=0;i<GetMobjeNum_now;i++){
		/* Position calculation */
		double _cos_rad , _sin_rad;
		double u,v;
		CvPoint local;
		Position pose;
		//_cos_rad = cos(-(robot_data.now.direction+robot_data.next.direction)/2);
		//_sin_rad = sin(-(robot_data.now.direction+robot_data.next.direction)/2);
		/*_cos_rad = cos(-robot_data.now.direction);
		_sin_rad = sin(-robot_data.now.direction);
		u = (double)data_people[i].x * _cos_rad  +  (double)data_people[i].y * _sin_rad;//Rounds
		v = (double)data_people[i].y * _cos_rad  -  (double)data_people[i].x * _sin_rad;//Rounds
		pose.y    = (float)v + robot_data.now.pose.y;
		pose.x    = (float)u + robot_data.now.pose.x;*/
		local.x=200 - ((int)( -data_people[i].y / GRID_SIZE ) + 100 );
		local.y=200 - ((int)( data_people[i].x / GRID_SIZE ) + 100 );
		pose=Convert_Local2Global(local,robot_data.now.pose,(robot_data.now.direction+robot_data.next.direction)/2);
		
		/* Rate calculation */
		velo = sqrt(POW(data_people[i].vx) + POW(data_people[i].vy));
		/* Calculate directions */
		dir = atan2(data_people[i].vy , data_people[i].vx);
		//dir += (robot_data.now.direction+robot_data.next.direction)/2;
		dir += robot_data.now.direction;


		//In fact this line to predict the position after LoopTime
		//I really put a bug fix for the  beware this is a bug because it might be
		
		//pose.x += ((float)LoopTime * velo )*cos(dir);
		//pose.y += ((float)LoopTime * velo )*sin(dir);

		array_Mobje[i]->SetPosition(pose.x , pose.y);
		array_Mobje[i]->LocalCPosition=local;
		array_Mobje[i]->direction = dir;
		array_Mobje[i]->velocity  = velo;

		data_pre_tmp[i].id = data_people[i].id;
		data_pre_tmp[i].x  = pose.x;
		data_pre_tmp[i].y  = pose.y;		

/*#ifndef Erase_Person
		// [JWvZAS_Î~̂Ƃĕۑ 
		local = Convert_Global2Local(robot_data.now.pose , robot_data.now.direction , array_Mobje[i]->CPosition);
		if(local.x != -1){
			LocalMap[local.x][local.y] |= SFLAG;
			LocalMap[local.x][local.y] &= ~UnKnown_FLAG;//mł͂ȂB
		}
#endif*/
	}
	//Last Data Storage

	for(int j=0;j<m_counter;j++){
		data_pre[j] = data_pre_tmp[j];
	}

	GetMobjeNum_pre = GetMobjeNum_now;
	step++;
}


OBJECT* OBJECT::SearchIDAddress(int id)//Address Search
{
	OBJECT *tmp;
	tmp = this;
	while(1){
		if(tmp == NULL){
			return 0;
		}else if (tmp->id == id){
			return tmp;
		}else if (tmp->id < id){
			tmp = tmp->next;
		}else{
			tmp = tmp->pre;
		}
	}
}
int  OBJECT::SetOptionalPolygon(int id)//Image rotation
{
	return SearchIDAddress(id)->SetOptionalPolygon();
}
int  OBJECT::SetOptionalPolygon()//Image rotation
{

	static int i , j , x , y ;
	static double u , v;
	double _cos_rad = cos( -1.0 * direction ) , _sin_rad = sin( -1.0 * direction );
	//Search
	//id set
	//static OBJECT *tmp;
	if( original_polygon == NULL ){
		fprintf(stderr,"error OBJECT::SetOptionalPolygon : Input == NULL");
		return -1;
	}
	if( optional_polygon == NULL ){
		fprintf(stderr,"error OBJECT::SetOptionalPolygon : Output == NULL\n");
		return -1;
	}
	if( height <= 0 ){
		fprintf(stderr,"error OBJECT::SetOptionalPolygon : height=%d\n",height);
		return -1;
	}
	if( width <= 0 ){
		fprintf(stderr,"error OBJECT::SetOptionalPolygon : width=%d\n",width);
		return -1;
	}
	static double r_centralpoint_h , r_centralpoint_w;
	r_centralpoint_h = (double)height/2.0;
	r_centralpoint_w = (double)width/2.0;

	for(i=0;i<height;i++){
		y = i - (int)r_centralpoint_h;
		for(j=0;j<width;j++){
			x = j - (int)r_centralpoint_w;
			u = (double)x * _cos_rad  +  (double)y * _sin_rad + r_centralpoint_w + 0.5;//rounds
			v = (double)y * _cos_rad  -  (double)x * _sin_rad + r_centralpoint_h + 0.5;//rounds
			if ( (int)v >= 0 && (int)v < height && (int)u >= 0 && (int)u < width )
				optional_polygon[j][i] = original_polygon[(int)u][(int)v];
			else optional_polygon[j][i] = UnKnown_FLAG;//Unknown area
		}
	}
	return 0;
}
void OBJECT::SetPolygonField()
{
	int i;
	original_polygon = (unsigned char**)calloc(width , sizeof(unsigned char*));
	optional_polygon = (unsigned char**)calloc(width , sizeof(unsigned char*));
	for(i=0;i<width;i++){
		original_polygon[i] = (unsigned char*)calloc(height , sizeof(unsigned char));
		optional_polygon[i] = (unsigned char*)calloc(height , sizeof(unsigned char));
	}
}

M_OBJE::M_OBJE(int width , int height , int id , float direction , float velocity , float omega, float radius)//Constructor
{

	int i,j;
	original_polygon = (unsigned char**)calloc(width , sizeof(unsigned char*));
	optional_polygon = (unsigned char**)calloc(width , sizeof(unsigned char*));
	for(i=0;i<width;i++){
		original_polygon[i] = (unsigned char*)calloc(height , sizeof(unsigned char));
		optional_polygon[i] = (unsigned char*)calloc(height , sizeof(unsigned char));
	}
	for(i=0;i<width;i++){
		for(j=0;j<height;j++){
			original_polygon[i][j] = UnKnown_FLAG;
			optional_polygon[i][j] = UnKnown_FLAG;
		}
	}
	//Initialization
	this->direction = direction;
	this->velocity  = velocity;
	this->width     = width;
	this->height    = height;
	this->omega     = omega;
	this->next      = NULL;
	this->pre       = NULL;
	this->id        = id;
}

M_OBJE::M_OBJE()//Constructor
{

	original_polygon = NULL;
	optional_polygon = NULL;
	this->direction = -1.f;
	this->velocity  = -1.f;
	this->width     = -1;
	this->height    = -1;
	this->omega     = -1.f;
	this->next      = NULL;
	this->pre       = NULL;
	this->id        = -1;
}
M_OBJE::~M_OBJE()//Destructor
{

	for(int i=0;i<width;i++){
		if(original_polygon[i] != NULL){
			free(original_polygon[i]);
			original_polygon[i] = NULL;
		}
		if(optional_polygon[i] != NULL){
			free(optional_polygon[i]);
			optional_polygon[i] = NULL;
		}
	}
	if(original_polygon != NULL){
		free(original_polygon);
		original_polygon = NULL;
	}
	if(optional_polygon != NULL){
		free(optional_polygon);
		optional_polygon = NULL;
	}
	

	original_polygon = NULL;
	optional_polygon = NULL;
	this->direction = -1.f;
	this->velocity  = -1.f;
	this->width     = -1;
	this->height    = -1;
	this->omega     = -1.f;
	this->next      = NULL;
	this->pre       = NULL;
	this->id        = -1;
}

void M_OBJE::construct(int width , int height , int id , float direction , float velocity , float omega, float radius)//Constructor
{
	//Instead of Constructors
	int i,j;
	original_polygon = (unsigned char**)calloc(width , sizeof(unsigned char*));
	optional_polygon = (unsigned char**)calloc(width , sizeof(unsigned char*));
	for(i=0;i<width;i++){
		original_polygon[i] = (unsigned char*)calloc(height , sizeof(unsigned char));
		optional_polygon[i] = (unsigned char*)calloc(height , sizeof(unsigned char));
	}
	for(i=0;i<width;i++){
		for(j=0;j<height;j++){
			original_polygon[i][j] = UnKnown_FLAG;
			optional_polygon[i][j] = UnKnown_FLAG;
		}
	}
	//Initialization
	this->direction = direction;
	this->velocity  = velocity;
	this->width     = width;
	this->height    = height;
	this->omega     = omega;
	this->next      = NULL;
	this->pre       = NULL;
	this->id        = id;
}


void OBJECT::SetPosition(float x , float y , int id)
{
	SearchIDAddress(id)->SetPosition(x,y);
}
void OBJECT::SetPosition(float x , float y)
{
	CPosition.x = x;
	CPosition.y = y;
}
int M_OBJE::MakeMObje(int width , int height , float direction , float velocity , float omega,float radius)//d return values
{
	OBJECT *tmp;
	static int tmp_ID;
	static int i,j;
	tmp = this;
	if(tmp == NULL)
		return 0;
	while(1){
		if(tmp->next == NULL){
			break;
		}else{
			tmp = tmp->next;
		}
	}
	tmp_ID = (tmp->id)+1;
	tmp->next = (M_OBJE*)calloc(1 , sizeof(M_OBJE));//Partitioning
	tmp = tmp->next;
	tmp->original_polygon = (unsigned char**)calloc(width , sizeof(unsigned char*));
	tmp->optional_polygon = (unsigned char**)calloc(width , sizeof(unsigned char*));
	for(i=0;i<width;i++){
		tmp->original_polygon[i] = (unsigned char*)calloc(height , sizeof(unsigned char));
		tmp->optional_polygon[i] = (unsigned char*)calloc(height , sizeof(unsigned char));
	}
	for(i=0;i<width;i++){
		for(j=0;j<height;j++){
			tmp->original_polygon[i][j] = UnKnown_FLAG;
			tmp->optional_polygon[i][j] = UnKnown_FLAG;
		}
	}
	tmp->direction = direction;
	((M_OBJE *)tmp)->velocity  = velocity;
	tmp->width     = width;
	tmp->height    = height;
	((M_OBJE *)tmp)->omega     = omega;
	tmp->next      = NULL;
	tmp->id        = tmp_ID;
	return tmp_ID;
}
void OBJECT::DeleteObje()
{
	static OBJECT *tmp;
	static int    tmp_ID;
	if (this == NULL) return;
	if(this->pre != NULL && this->next != NULL){
		/*Address change bridge*/
		this->pre->next = this->next;
		/*ID Align*/
		tmp = this->pre;
		tmp_ID = tmp->id;
		while(1){
			tmp = tmp->next;
			if(tmp == NULL)
				break;
			tmp_ID++;
			tmp->id = tmp_ID;
		}
	}else if(this->pre == NULL && this->next != NULL){//Were the first node
		/* ID Align */
		tmp = this->next;
		tmp_ID = 1;
		while(1){
			tmp->id = tmp_ID;
			tmp = tmp->next;
			if(tmp == NULL)
				break;
			tmp_ID++;
		}
	}else if(this->next == NULL && this->pre != NULL){//This is the final node were
		/*Address change bridge*/
		this->pre->next = NULL;
	}
	/* Delete */
	for(int i=0;i<width;i++){
		free(original_polygon[i]);
		free(optional_polygon[i]);
	}
	free(original_polygon);
	free(optional_polygon);
	free(this);
}
void OBJECT::DeleteObje(int id)
{
	SearchIDAddress(id)->DeleteObje();
}
void M_OBJE::SetCircle(int r , unsigned char FLAG_TYPE)
{
	static float dst,dx,dy;
	static int i,j;
	//printf("%d %d\n",(int)CPosition.x , (int)CPosition.y);
	//printf("%d %d\n",(int)width , (int)height);
	//cvWaitKey();
	for(i=0;i<width;i++){
		for(j=0;j<height;j++){
			dx = (float)width/2 - (float)i;
			dx *= dx;
			dy = (float)height/2 - (float)j;
			dy *= dy;
			dst = dx + dy;
			if(dst <= (r*r)){
				original_polygon[i][j] &= ~UnKnown_FLAG;
				original_polygon[i][j] |= FLAG_TYPE;
			}
		}
	}
}

S_OBJE::S_OBJE(int width , int height , int id, float direction)//Constructor
{

	int i,j;
	original_polygon = (unsigned char**)calloc(width , sizeof(unsigned char*));
	optional_polygon = (unsigned char**)calloc(width , sizeof(unsigned char*));
	for(i=0;i<width;i++){
		original_polygon[i] = (unsigned char*)calloc(height , sizeof(unsigned char));
		optional_polygon[i] = (unsigned char*)calloc(height , sizeof(unsigned char));
	}
	for(i=0;i<width;i++){
		for(j=0;j<height;j++){
			original_polygon[i][j] = UnKnown_FLAG;
			optional_polygon[i][j] = UnKnown_FLAG;
		}
	}
	this->direction = direction;
	this->width     = width;
	this->height    = height;
	this->next      = NULL;
	this->pre		= NULL;
	this->id        = id;
}
S_OBJE::~S_OBJE()//Destructor
{

	for(int i=0;i<width;i++){
		if(original_polygon[i] != NULL){
			free(original_polygon[i]);
			original_polygon[i] = NULL;
		}
		if(optional_polygon[i] != NULL){
			free(optional_polygon[i]);
			optional_polygon[i] = NULL;
		}
	}
	if(original_polygon != NULL){
		free(original_polygon);
		original_polygon = NULL;
	}
	if(optional_polygon != NULL){
		free(optional_polygon);
		optional_polygon = NULL;
	}
}
int S_OBJE::MakeSObje(int width , int height , float direction)//id return values
{
	OBJECT *tmp;
	static int tmp_ID;
	static int i,j;
	tmp = this;
	if(tmp == NULL)
		return 0;
	while(1){
		if(tmp->next == NULL){
			break;
		}else{
			tmp = tmp->next;
		}
	}
	tmp_ID = (tmp->id)+1;
	tmp->next = (S_OBJE*)calloc(1 , sizeof(S_OBJE));//Partitioning
	tmp->next->pre = tmp;
	tmp = tmp->next;
	tmp->original_polygon = (unsigned char**)calloc(width , sizeof(unsigned char*));
	tmp->optional_polygon = (unsigned char**)calloc(width , sizeof(unsigned char*));
	for(i=0;i<width;i++){
		tmp->original_polygon[i] = (unsigned char*)calloc(height , sizeof(unsigned char));
		tmp->optional_polygon[i] = (unsigned char*)calloc(height , sizeof(unsigned char));
	}
	for(i=0;i<width;i++){
		for(j=0;j<height;j++){
			tmp->original_polygon[i][j] = UnKnown_FLAG;
			tmp->optional_polygon[i][j] = UnKnown_FLAG;
		}
	}
	tmp->direction = direction;
	tmp->width     = width;
	tmp->height    = height;
	tmp->next      = NULL;
	tmp->id        = tmp_ID;
	return tmp_ID;
}

void S_OBJE::SetRectangle(CvRect rect)
{
	static int i,j;
	for(i=0;i<rect.width;i++){
		for(j=0;j<rect.height;j++){
			original_polygon[i+rect.x][j+rect.y] &= ~UnKnown_FLAG;
			original_polygon[i+rect.x][j+rect.y] |= SFLAG;
			//printf("original_polygon[%d][%d] = %d\n",i,j,original_polygon[i][j]);
			//cvWaitKey();
		}
	}
}

/**********Collision detection*********/

unsigned short InsideOfStaticObstacle(R_OBJE *robot , unsigned char **LocalMap , DATA_LOGGER robot_data )//Collision detection
{
	static CvPoint R_pose_on_LMap;//Robot position on a local map
	
	/*Calculate the robot position on a local map*/
	R_pose_on_LMap = Convert_Global2Local(robot_data.now.pose , robot_data.now.direction , robot->CPosition);
	
	if(R_pose_on_LMap.x == -1){//Outside
		return 1;//Determined to hit
	}

	if((LocalMap[R_pose_on_LMap.x][R_pose_on_LMap.y] & SFLAG) != 0){//The position of the robot, if there is an object
		return 1;//Bumped.
	}
	if((LocalMap[R_pose_on_LMap.x][R_pose_on_LMap.y] & R_AvailableFLAG) == 0){//Region must position of the robot can move
		return 1;//Bumped.
	}
	return 0;
}

/***** Calculate the position of local maps from the global position *****/
CvPoint Convert_Global2Local(R_OBJE *robot , float *xg)
{
	static CvPoint local;

	static int r_centralpoint_h , r_centralpoint_w;
	static double _cos_rad , _sin_rad;
	static float x,y;

	_cos_rad = cos(1.0*robot->direction + PI/2);
	_sin_rad = sin(1.0*robot->direction + PI/2);

	y = xg[2] - robot->CPosition.y;//unitFmm
	x = xg[1] - robot->CPosition.x;

	local.x = (int)((double)x * _cos_rad  +  (double)y * _sin_rad + 0.5);
	local.y = (int)((double)y * _cos_rad  -  (double)x * _sin_rad + 0.5);

	local.x /= GRID_SIZE;
	local.y /= GRID_SIZE;

	local.x += G_SELL_SIZE/GRID_SIZE/2;
	local.y += G_SELL_SIZE/GRID_SIZE/2;

	if( (local.x < 0) || (local.y < 0) || (local.x >= G_SELL_SIZE/GRID_SIZE) || (local.y >= G_SELL_SIZE/GRID_SIZE)){
		local.x = -1;
		local.y = -1;
	}


	return local;
}

CvPoint Convert_Global2Local(R_OBJE *robot , Position pose)
{
	static CvPoint local;

	static int r_centralpoint_h , r_centralpoint_w;
	static double _cos_rad , _sin_rad;
	static float x,y;

	_cos_rad = cos(1.0*robot->direction + PI/2);
	_sin_rad = sin(1.0*robot->direction + PI/2);

	y = pose.y - robot->CPosition.y;//unitFmm
	x = pose.x - robot->CPosition.x;

	local.x = (int)((double)x * _cos_rad  +  (double)y * _sin_rad + 0.5);
	local.y = (int)((double)y * _cos_rad  -  (double)x * _sin_rad + 0.5);

	local.x /= GRID_SIZE;
	local.y /= GRID_SIZE;

	local.x += G_SELL_SIZE/GRID_SIZE/2;
	local.y += G_SELL_SIZE/GRID_SIZE/2;

	if( (local.x < 0) || (local.y < 0) || (local.x >= G_SELL_SIZE/GRID_SIZE) || (local.y >= G_SELL_SIZE/GRID_SIZE)){
		local.x = -1;
		local.y = -1;
	}


	return local;
}

CvPoint Convert_Global2Local(Position robot_position , float robot_direction , Position pose)
{
	static CvPoint local;

	static int r_centralpoint_h , r_centralpoint_w;
	static double _cos_rad , _sin_rad;
	static float x,y;

	_cos_rad = cos(1.0*robot_direction + PI/2);
	_sin_rad = sin(1.0*robot_direction + PI/2);

	y = pose.y - robot_position.y;//unitFmm
	x = pose.x - robot_position.x;

	local.x = (int)((double)x * _cos_rad  +  (double)y * _sin_rad + 0.5);
	local.y = (int)((double)y * _cos_rad  -  (double)x * _sin_rad + 0.5);

	local.x /= GRID_SIZE;
	local.y /= GRID_SIZE;

	local.x += G_SELL_SIZE/GRID_SIZE/2;
	local.y += G_SELL_SIZE/GRID_SIZE/2;

	if( (local.x < 0) || (local.y < 0) || (local.x >= G_SELL_SIZE/GRID_SIZE) || (local.y >= G_SELL_SIZE/GRID_SIZE)){
		local.x = -1;
		local.y = -1;
	}


	return local;
}

/***** Calculate the global position from the position of the local map *****/
Position Convert_Local2Global(CvPoint local_map_position , R_OBJE *robot)
{
	static Position global_map_position;
	static double _cos_rad , _sin_rad;
	static float x,y;

	_cos_rad = cos(-1.0*robot->direction - PI/2);
	_sin_rad = sin(-1.0*robot->direction - PI/2);

	y = local_map_position.y - G_SELL_SIZE/GRID_SIZE/2;
	x = local_map_position.x - G_SELL_SIZE/GRID_SIZE/2;

	global_map_position.x = (float)((double)x * _cos_rad  +  (double)y * _sin_rad);
	global_map_position.y = (float)((double)y * _cos_rad  -  (double)x * _sin_rad);

	global_map_position.x *= (float)GRID_SIZE;
	global_map_position.y *= (float)GRID_SIZE;

	global_map_position.x += robot->CPosition.x;
	global_map_position.y += robot->CPosition.y;

	return global_map_position;
}

Position Convert_Local2Global(CvPoint local_map_position , Position robot_position , float robot_direction)
{
	static Position global_map_position;
	static double _cos_rad , _sin_rad;
	static float x,y;

	_cos_rad = cos(-1.0*robot_direction - PI/2);
	_sin_rad = sin(-1.0*robot_direction - PI/2);

	y = local_map_position.y - G_SELL_SIZE/GRID_SIZE/2;
	x = local_map_position.x - G_SELL_SIZE/GRID_SIZE/2;

	global_map_position.x = (float)((double)x * _cos_rad  +  (double)y * _sin_rad);
	global_map_position.y = (float)((double)y * _cos_rad  -  (double)x * _sin_rad);

	global_map_position.x *= (float)GRID_SIZE;
	global_map_position.y *= (float)GRID_SIZE;

	global_map_position.x += robot_position.x;
	global_map_position.y += robot_position.y;

	return global_map_position;
}
