// ================================================================================== //
// Name of File				: save.h
// Vendor					: AISL-TUT
// Version					: 1.0.0
// ================================================================================== //

#ifndef __SAVE_H__
#define __SAVE_H__//Prevent multiple inclusion

#include "tree_new.h"

typedef struct{
	FILE* fp;
	int average_make_node_num;//Hitoshi Hitoshi nodes
	int make_node_counter;
}SAVE_STRUCT;

class Save_struct{//Data storage related
protected:
	FILE *fp;//Destination file
public:
	int average_make_node_num;//Hitoshi Hitoshi nodes
	int make_node_counter;
	Save_struct(const char *filename = "data_log.txt");//Constructor
	~Save_struct();//Destructor

	void calc_data(int node_num, TREE *path);//Updated
};

#endif