#include "httpc.h"


using namespace std;

int main()
{
	sys::SocketBase::initializeWinSock();

	HTTPC httpc;

	httpc.initialize( 8080, "../../../../VSData/templ.html" );

	string state = "OPE estimation";
	vector< string > next_status;
	vector< bool > disabled_status;
	next_status.push_back( "HIRO object manipulation" );	disabled_status.push_back( true );
	next_status.push_back( "HIRO tray manipulation" );		disabled_status.push_back( true );
	next_status.push_back( "AGV homeward" );							disabled_status.push_back( true );

	httpc.setHTMLParameter( state, next_status, disabled_status );

	int count = 0;
	while( true ) {
		if( httpc.waitForPOST() ) {
			state += 'X';
			next_status.clear();																disabled_status.clear();
			next_status.push_back( "HIRO tray manipulation" );	disabled_status.push_back( true );
			httpc.setHTMLParameter( state, next_status, disabled_status );
			Sleep( 2000 );
			httpc.postDataUpdated();
		}
		else if( count == 500 ) {
			disabled_status.at(0) = false;
			httpc.setHTMLParameter( state, next_status, disabled_status );
			httpc.push();
		}
		else if( count == 1000 ) {
			state = "Error";
			next_status.clear();					disabled_status.clear();
			next_status.push_back( "X" );	disabled_status.push_back( false );
			httpc.setHTMLParameter( state, next_status, disabled_status );
			httpc.push();
		}
		printf("count = %d\n", count );
		count ++;
		Sleep(50);
	}

	getchar();

	httpc.finalize();

	return 0;
}