#include <iostream>
#include "crtsec.h"
#include "../thread/thread.h"


static const int th_n = 10;
int id[th_n] = {};
int v = 0;


sys::CriticalSection cs;
sys::Thread *th;


static unsigned int __stdcall process(void *data_int)
{
	int data = *((int *) data_int);
	while(id[data] != -1){
		cs.enter();
		{

			int v_tmp = v;
			v_tmp ++;
			v = v_tmp;

			printf("data = %d, v_tmp = %d, v = %d\n", data, v_tmp, v);

		}
		cs.exit();
		Sleep(100);
	}
	return 0;
}


int main()
{
	cs.initialize();
	th = new sys::Thread[th_n];
	for(int i = 0; i < th_n; i ++){
		id[i] = i;
		th[i].start(process, &id[i]);
	}

	getchar();
	for(int i = 0; i < th_n; i ++){
		id[i] = -1;
		th[i].stop();
	}

	cs.finalize();
	delete [] th;

	return EXIT_SUCCESS;
}


